Coin: SoTextureCubeMap Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoTextureCubeMap Class Reference
Node Classes

The SoTextureCubeMap class is used to map a cube map onto subsequent shape nodes. More...

`#include <Inventor/nodes/SoTextureCubeMap.h>`

Inheritance diagram for SoTextureCubeMap:

## Public Types
enum | Model { MODULATE = SoMultiTextureImageElement::MODULATE , DECAL = SoMultiTextureImageElement::DECAL , BLEND = SoMultiTextureImageElement::BLEND , REPLACE = SoMultiTextureImageElement::REPLACE }
enum | Wrap { REPEAT = SoMultiTextureImageElement::REPEAT , CLAMP = SoMultiTextureImageElement::CLAMP }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoTextureCubeMap (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)
Public Member Functions inherited from SoTexture
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SbBool | readImage (const SbString &fname, int &w, int &h, int &nc, unsigned char *&bytes)
Static Public Member Functions inherited from SoTexture
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | cleanupClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoMFString | filenames
SoSFImage | imagePosX
SoSFImage | imageNegX
SoSFImage | imagePosY
SoSFImage | imageNegY
SoSFImage | imagePosZ
SoSFImage | imageNegZ
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTextureCubeMap ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)
Protected Member Functions inherited from SoTexture
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTexture
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTextureCubeMap class is used to map a cube map onto subsequent shape nodes.

Shape nodes within the scope of SoTextureCubeMap nodes in the scene graph (i.e. below the same SoSeparator and to the right hand side of the SoTextureCubeMap) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc.) for information about the specifics of how the textures will be applied.

FILE FORMAT/DEFAULTS:

TextureCubeMap {
filenames [ ]
imagePosX 0 0 0
imageNegX 0 0 0
imagePosY 0 0 0
imageNegY 0 0 0
imagePosZ 0 0 0
imageNegZ 0 0 0
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
}
SoTextureCubeMap::wrapS
SoSFEnum wrapS
Definition SoTextureCubeMap.h:78
SoTextureCubeMap::MODULATE
@ MODULATE
Definition SoTextureCubeMap.h:58
SoTextureCubeMap::blendColor
SoSFColor blendColor
Definition SoTextureCubeMap.h:81
SoTextureCubeMap::model
SoSFEnum model
Definition SoTextureCubeMap.h:80
SoTextureCubeMap::filenames
SoMFString filenames
Definition SoTextureCubeMap.h:69
SoTextureCubeMap::imageNegY
SoSFImage imageNegY
Definition SoTextureCubeMap.h:74
SoTextureCubeMap::REPEAT
@ REPEAT
Definition SoTextureCubeMap.h:65
SoTextureCubeMap::imageNegZ
SoSFImage imageNegZ
Definition SoTextureCubeMap.h:76
SoTextureCubeMap::imagePosZ
SoSFImage imagePosZ
Definition SoTextureCubeMap.h:75
SoTextureCubeMap::wrapT
SoSFEnum wrapT
Definition SoTextureCubeMap.h:79
SoTextureCubeMap::imagePosY
SoSFImage imagePosY
Definition SoTextureCubeMap.h:73
SoTextureCubeMap::imageNegX
SoSFImage imageNegX
Definition SoTextureCubeMap.h:72
SoTextureCubeMap::imagePosX
SoSFImage imagePosX
Definition SoTextureCubeMap.h:71

Since
  Coin 3.0

## Member Enumeration Documentation

## ◆ Model

enum SoTextureCubeMap::Model

Texture mapping model, for deciding how to "merge" the texture map with the object it is mapped onto.

Enumerator
MODULATE | Texture color is multiplied by the polygon color. The result will be Phong shaded (if light model is PHONG).
DECAL | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Has undefined behaviour for grayscale and grayscale-alpha textures.
BLEND | This model is normally used with monochrome textures (i.e. textures with one or two components). The first component, the intensity, is then used to blend between the shaded color of the polygon and the SoTextureCubeMap::blendColor.
REPLACE | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Supports grayscale and grayscale alpha textures. This feature requires OpenGL 1.1. MODULATE will be used if OpenGL version < 1.1 is detected. Please note that using this texture model will make your Inventor files incompatible with older versions of Coin and Inventor. You need Coin >= 2.2 or TGS Inventor 4.0 to load Inventor files that uses the REPLACE texture model.

## ◆ Wrap

enum SoTextureCubeMap::Wrap

Enumeration of wrapping strategies which can be used when the texture map doesn't cover the full extent of the geometry.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

## ◆ SoTextureCubeMap()

SoTextureCubeMap::SoTextureCubeMap | ( | void |  | ) |

Constructor.

## ◆ ~SoTextureCubeMap()

SoTextureCubeMap::~SoTextureCubeMap | ( |  | ) |
| protectedvirtual

Destructor. Frees up internal resources used to store texture image data.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoTextureCubeMap::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoTextureCubeMap::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoTexture.

## ◆ getFieldDataPtr()

const SoFieldData ** SoTextureCubeMap::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoTextureCubeMap::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTexture.

## ◆ doAction()

void SoTextureCubeMap::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoTexture.

## ◆ GLRender()

void SoTextureCubeMap::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoTexture.

## ◆ callback()

void SoTextureCubeMap::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoTexture.

## ◆ rayPick()

void SoTextureCubeMap::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

## ◆ readImage()

SbBool SoTextureCubeMap::readImage | ( | const SbString & | fname,
|  | int & | w,
|  | int & | h,
|  | int & | nc,
|  | unsigned char *& | bytes )
| static

Not implemented in Coin; should probably not have been public in the original SGI Open Inventor API. We'll consider to implement it if requested.

## ◆ readInstance()

SbBool SoTextureCubeMap::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

## ◆ notify()

void SoTextureCubeMap::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

## ◆ getReadStatus()

int SoTextureCubeMap::getReadStatus | ( | void |  | ) |
| protected

Returns read status. 1 for success, 0 for failure.

## ◆ setReadStatus()

void SoTextureCubeMap::setReadStatus | ( | int | s | ) |
| protected

Sets read status.

See also
  getReadStatus()

## Member Data Documentation

## ◆ filenames

SoMFString SoTextureCubeMap::filenames

The filenames in this order: negx, posx, negy, posy, negz, posz.

## ◆ imagePosX

SoSFImage SoTextureCubeMap::imagePosX

The pos-x image.

## ◆ imageNegX

SoSFImage SoTextureCubeMap::imageNegX

The neg-x image.

## ◆ imagePosY

SoSFImage SoTextureCubeMap::imagePosY

The neg-y image.

## ◆ imageNegY

SoSFImage SoTextureCubeMap::imageNegY

The neg-y image.

## ◆ imagePosZ

SoSFImage SoTextureCubeMap::imagePosZ

The pos-z image.

## ◆ imageNegZ

SoSFImage SoTextureCubeMap::imageNegZ

The neg-z image.

## ◆ wrapS

SoSFEnum SoTextureCubeMap::wrapS

Wrapping strategy for the S coordinate when the texture map is narrower than the object to map onto.

Default value is SoTextureCubeMap::REPEAT.

## ◆ wrapT

SoSFEnum SoTextureCubeMap::wrapT

Wrapping strategy for the T coordinate when the texture map is shorter than the object to map onto.

Default value is SoTextureCubeMap::REPEAT.

## ◆ model

SoSFEnum SoTextureCubeMap::model

Texture mapping model for how the texture map is "merged" with the polygon primitives it is applied to. Default value is SoTextureCubeMap::MODULATE.

## ◆ blendColor

SoSFColor SoTextureCubeMap::blendColor

Blend color. Used when SoTextureCubeMap::model is SoTextureCubeMap::BLEND.

Default color value is [0, 0, 0], black, which means no contribution to the blending is made.

The documentation for this class was generated from the following files:

- SoTextureCubeMap.h
- SoTextureCubeMap.cpp